﻿using System;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace RestfulClientPlugin
{
    [ServiceContract(Name = "UniteRestServices")]
    public interface IUniteRestServices
    {
        [OperationContract]
        [WebGet(UriTemplate = Routing.GetNumPresenters, BodyStyle = WebMessageBodyStyle.Bare)]
        int getNumPresenters();
        [OperationContract]
        [WebGet(UriTemplate = Routing.GetNumUsers, BodyStyle = WebMessageBodyStyle.Bare)]
        int getNumUsers();
        [OperationContract]
        [WebGet(UriTemplate = Routing.GetPin, BodyStyle = WebMessageBodyStyle.Bare)]
        int getCurrentPin();
        [OperationContract]
        [WebInvoke(Method = "POST", UriTemplate = Routing.ShowToast, BodyStyle = WebMessageBodyStyle.Wrapped, RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        bool ShowToast(string message);
        [OperationContract]
        [WebInvoke(Method = "POST", UriTemplate = Routing.StopAllPresenters, BodyStyle = WebMessageBodyStyle.Wrapped, RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        bool WebStopAllPresenters();

        [OperationContract]
        [WebInvoke(Method = "GET", UriTemplate = Routing.MakeRESTfulAPICall, BodyStyle = WebMessageBodyStyle.Wrapped, RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        string MakeExampleRestCall();
    }

}