﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.ServiceModel.Web;
using Intel.CFC.Plugin;
using System.ServiceModel;
using System.Xml.Serialization;
using System.Collections.Generic;

namespace RestfulClientPlugin
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, IncludeExceptionDetailInFaults = true)]
    public class RestfulUniteClientPlugin : Intel.CFC.Plugin.CFCPlugin, IUniteRestServices
    {
        int numUsers = 0;
        int numPresenters = 0;
        private PluginInfo m_PluginDetails = new PluginInfo();
        private PluginUI _pluginUi;
        private PluginInfo _pluginInfo;
        private WebServiceHost _serviceHost;

        public override string GetHubText()
        {
            return "";
            //throw new NotImplementedException();
        }

        public override PluginInfo GetPluginInfo()
        {
            return m_PluginDetails;
            //throw new NotImplementedException();
        }

        public override PluginUI GetUI(UserEventArgs e)
        {
            return null;
            //throw new NotImplementedException();
        }

        public override void Load()
        {
            m_PluginDetails.Name = "Intel Unite Plugin for RESTful Access";
            m_PluginDetails.Id = new Guid("13422566-2614-2457-3854-358792177999");
            m_PluginDetails.Description = "Allows remote access to various Unite values";
            m_PluginDetails.Copyright = "Copyright (C) 2017 Intel Corporation - All Rights Reserved";
            m_PluginDetails.Company = "Intel Corporation";
            _serviceHost = new WebServiceHost(this, new Uri("http://localhost:8001/Unite/"));
            _serviceHost.Open();
            _pluginInfo = m_PluginDetails;
            _pluginUi = BlankUI();
            ShowHubToast("Plugin Loaded", null, 10);
            
            //throw new NotImplementedException();
        }

        public override void UIElementEvent(UIEventArgs e)
        {
            //throw new NotImplementedException();
        }

        public override void UnLoad()
        {
            _serviceHost.Close();
            ShowHubToast("Plugin UnLoaded", null, 10);
            //throw new NotImplementedException();
        }

        public override void UserConnected(UserEventArgs e)
        {
            numUsers++;
            ShowHubToast("Number of connected users increased to " + numUsers, null, 10);
            //throw new NotImplementedException();
        }

        public override void UserDisconnected(UserEventArgs e)
        {
            numUsers--;
            ShowHubToast("Number of connected users decreased to " + numUsers, null, 10);
            //throw new NotImplementedException();
        }

        public override void UserPresentationEnd(UserEventArgs e)
        {
            numPresenters--;
            ShowHubToast("Number of presenting users decreased to " + numUsers, null, 10);
            //throw new NotImplementedException();
        }

        public override void UserPresentationStart(UserEventArgs e)
        {
            numPresenters++;
            ShowHubToast("Number of presenting users increased to " + numUsers, null, 10);
            //throw new NotImplementedException();
        }

        private PluginUI BlankUI()
        {
            PluginUI p = new PluginUI();
            p.pluginInfo = _pluginInfo;
            p.Groups = new List<PluginUIElementGroup>();
            return p;
        }

        public int getNumPresenters()
        {
            ShowHubToast("Number of presenters requested", null, 10);
            return numPresenters;
        }

        public int getNumUsers()
        {
            ShowHubToast("Number of users requested", null, 10);
            return numUsers;
        }

        public int getCurrentPin()
        {
            ShowHubToast("Current pin requested", null, 10);
            return 123456;
        }

        public bool ShowToast(string message)
        {
            ShowHubToast(message, null, 10);
            return true;
        }

        public bool WebStopAllPresenters()
        {
            FireStopAllPresenters();
            return true;
        }
        public string MakeExampleRestCall()
        {
            HttpClient client = new HttpClient();
            client.BaseAddress = new Uri("http://127.0.0.1:8000/Unite/RoomOccupied");

            client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));

            HttpResponseMessage response = client.GetAsync("").Result; //this blocks

            if (response.IsSuccessStatusCode)
            {
                var responseString = response.Content.ReadAsStringAsync();
                return responseString.Result;
            } else
            {
                return "Fail!";
            }
        }
    }
    
}
